# -*- coding: utf-8 -*-
# +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# This file is part of the Exudyn GUI project.
#
# Filename: guiForms/nodeTypeOptions.py
#
# Description:
#     Auto-generated list of all valid nodeType options for Exudyn nodes.
#     Used by autoGeneratedForm.py to populate nodeType dropdown menus.
#
#     Includes:
#       - Full list of available node types (`NODE_TYPE_OPTIONS`)
#       - Fallback default selection (`NODE_TYPE_DEFAULT`)
#
# Authors:  Michael Pieber
# Date:     2025-07-03
#
# License:  BSD 3-Clause License
# +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# Auto-generated list of all valid nodeType options for Exudyn nodes
# This file is imported by autoGeneratedForm.py to populate the nodeType dropdown

NODE_TYPE_OPTIONS = [
    "1D",
    "GenericAE",
    "GenericData",
    "GenericODE1",
    "GenericODE2",
    "Point",
    "Point2D",
    "Point2DSlope1",
    "PointGround",
    "PointSlope1",
    "PointSlope12",
    "PointSlope23",
    "RigidBody2D",
    "RigidBodyEP",
    "RigidBodyRotVecLG",
    "RigidBodyRxyz",
]
# If you want to change the default, set NODE_TYPE_DEFAULT below
NODE_TYPE_DEFAULT = "RotationEulerParameters" if "RotationEulerParameters" in NODE_TYPE_OPTIONS else NODE_TYPE_OPTIONS[0]
